var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useEffect, useState } from 'react';
import { useApiContext } from './CacheContext';
import { areObjectsEqual, createRequest, normalizeError } from './utils';
/*
Usage:
GET
const {data, isLoading, isError, error} = useApi<ResponseType, PostDataType>({
    apiId: 'some-api'
    apiUrl: 'https://api.example.com',
    method: Method.GET
})

POST, PUT, PATCH
const {data, isLoading, isError, error} = useApi<ResponseType, PostDataType>({
    apiId: 'some-api'
    apiUrl: 'https://api.example.com',
    method: Method.POST,
    data: {firstName: "Test"}
})
 */
var interval;
var useApi = function (_a) {
    var apiId = _a.apiId, apiUrl = _a.apiUrl, method = _a.method, data = _a.data, _b = _a.headers, headers = _b === void 0 ? {} : _b, cacheExpiry = _a.cacheExpiry, retry = _a.retry, onSuccess = _a.onSuccess, onError = _a.onError, pollInterval = _a.pollInterval, _c = _a.enabled, enabled = _c === void 0 ? true : _c;
    var _d = useApiContext(), getCache = _d.getCache, setCache = _d.setCache, baseApiUrl = _d.baseApiUrl;
    var retryTimes = retry || 0;
    var _e = useState({
        data: undefined,
        error: null,
        isError: false,
        isLoading: false,
        isRetrying: false,
        triggerApi: function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/];
        }); }); },
    }), state = _e[0], setState = _e[1];
    var finalUrl = baseApiUrl ? baseApiUrl + apiUrl : apiUrl;
    var apiIdentifier = apiId || JSON.stringify({ finalUrl: finalUrl, method: method, data: data });
    var isCacheOutdated = function (cachedData, newResponseData) {
        return !areObjectsEqual(cachedData, newResponseData);
    };
    var triggerAPI = function () { return __awaiter(void 0, void 0, void 0, function () {
        var cachedResponse, response, responseText, responseData, error_1, normalError;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    cachedResponse = getCache(apiIdentifier);
                    if (cachedResponse) {
                        // return the cached response immediately
                        setState(__assign({ data: cachedResponse, error: null, isError: false, isLoading: false, isRetrying: false, triggerApi: triggerAPI }, (process.env.NODE_ENV !== 'production'
                            ? {
                                cached: true,
                            }
                            : {})));
                    }
                    return [4 /*yield*/, createRequest({
                            apiUrl: finalUrl,
                            requestInfo: {
                                method: method,
                                body: JSON.stringify(data),
                                headers: headers,
                            },
                        })];
                case 1:
                    response = _a.sent();
                    return [4 /*yield*/, response.text()];
                case 2:
                    responseText = _a.sent();
                    responseData = responseText && responseText.length > 0 ? JSON.parse(responseText) : {};
                    // if API fails, throw error
                    if (!response.ok) {
                        throw responseData;
                    }
                    // compare the old cached data vs the new data
                    // if the cached data is old, replace it with the new response data
                    onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(responseData);
                    if (isCacheOutdated(cachedResponse, responseData)) {
                        setState({
                            data: responseData,
                            error: null,
                            isError: false,
                            isLoading: false,
                            isRetrying: false,
                            triggerApi: triggerAPI,
                        });
                        setCache(apiIdentifier, responseData, cacheExpiry);
                    }
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    // if retry is specified, trigger the API call again, until retryTimes is 0
                    if (retryTimes && retryTimes > 0) {
                        retryTimes--;
                        setState({
                            data: undefined,
                            error: null,
                            isError: false,
                            isLoading: true,
                            isRetrying: true,
                            triggerApi: triggerAPI,
                        });
                        triggerAPI();
                    }
                    else {
                        normalError = normalizeError(error_1);
                        onError === null || onError === void 0 ? void 0 : onError(normalError);
                        setState({
                            data: undefined,
                            error: normalError,
                            isLoading: false,
                            isError: true,
                            isRetrying: false,
                            triggerApi: triggerAPI,
                        });
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        if (enabled) {
            setState({
                data: undefined,
                error: null,
                isError: false,
                isLoading: true,
                isRetrying: false,
                triggerApi: triggerAPI,
            });
            triggerAPI();
            if (pollInterval) {
                interval = setInterval(triggerAPI, pollInterval);
            }
        }
        return function () {
            if (interval) {
                clearInterval(interval);
            }
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [apiId, pollInterval]);
    return state;
};
export { useApi };
//# sourceMappingURL=useApi.js.map